import React from 'react';
import { CodeSnippetType, FontSize } from './CodeSnippet.types';
import InlineCode from './CodeTypes/InlineCode/InlineCode';
import MultiCode from './CodeTypes/MultiCode/MultiCode';
import SingleCode from './CodeTypes/SingleCode/SingleCode';
import "./style/index.css";
var CodeSnippet = function CodeSnippet(_ref) {
  var _ref$type = _ref.type,
    type = _ref$type === void 0 ? CodeSnippetType.INLINE : _ref$type,
    _ref$languages = _ref.languages,
    languages = _ref$languages === void 0 ? ['javascript', 'typescript', 'json'] : _ref$languages,
    _ref$children = _ref.children,
    children = _ref$children === void 0 ? '' : _ref$children,
    _ref$colorSyntax = _ref.colorSyntax,
    colorSyntax = _ref$colorSyntax === void 0 ? false : _ref$colorSyntax,
    _ref$fontSize = _ref.fontSize,
    fontSize = _ref$fontSize === void 0 ? FontSize.SMALL : _ref$fontSize,
    _ref$tooltipTitleHove = _ref.tooltipTitleHover,
    tooltipTitleHover = _ref$tooltipTitleHove === void 0 ? 'Copy' : _ref$tooltipTitleHove,
    _ref$tooltipTitleClic = _ref.tooltipTitleClick,
    tooltipTitleClick = _ref$tooltipTitleClic === void 0 ? 'Copied!' : _ref$tooltipTitleClic,
    _ref$labelBeforeExpan = _ref.labelBeforeExpanded,
    labelBeforeExpanded = _ref$labelBeforeExpan === void 0 ? 'Show more' : _ref$labelBeforeExpan,
    _ref$labelAfterExpand = _ref.labelAfterExpanded,
    labelAfterExpanded = _ref$labelAfterExpand === void 0 ? 'Show less' : _ref$labelAfterExpand,
    _ref$wrap = _ref.wrap,
    wrap = _ref$wrap === void 0 ? false : _ref$wrap,
    _ref$rows = _ref.rows,
    rows = _ref$rows === void 0 ? 6 : _ref$rows,
    className = _ref.className,
    onExpand = _ref.onExpand,
    onCopy = _ref.onCopy,
    customTriggerComponent = _ref.customTriggerComponent,
    _ref$expanded = _ref.expanded,
    expanded = _ref$expanded === void 0 ? false : _ref$expanded,
    _ref$hideExpandButton = _ref.hideExpandButton,
    hideExpandButton = _ref$hideExpandButton === void 0 ? false : _ref$hideExpandButton,
    _ref$hideCopyButton = _ref.hideCopyButton,
    hideCopyButton = _ref$hideCopyButton === void 0 ? false : _ref$hideCopyButton;
  switch (type) {
    case CodeSnippetType.SINGLE_LINE:
      return /*#__PURE__*/React.createElement(SingleCode, {
        fontSize: fontSize,
        tooltipTitleHover: tooltipTitleHover,
        tooltipTitleClick: tooltipTitleClick,
        className: className,
        onCopy: onCopy,
        customTriggerComponent: customTriggerComponent
      }, children);
    case CodeSnippetType.MULTI_LINE:
      return /*#__PURE__*/React.createElement(MultiCode, {
        languages: languages,
        colorSyntax: colorSyntax,
        fontSize: fontSize,
        tooltipTitleHover: tooltipTitleHover,
        tooltipTitleClick: tooltipTitleClick,
        labelBeforeExpanded: labelBeforeExpanded,
        labelAfterExpanded: labelAfterExpanded,
        expanded: expanded,
        className: className,
        wrap: wrap,
        rows: rows,
        onExpand: onExpand,
        onCopy: onCopy,
        customTriggerComponent: customTriggerComponent,
        hideExpandButton: hideExpandButton,
        hideCopyButton: hideCopyButton
      }, children);
    default:
      return /*#__PURE__*/React.createElement(InlineCode, {
        className: className
      }, children);
  }
};
export default CodeSnippet;