function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
import copy from 'copy-to-clipboard';
import React from 'react';
import AnimateHeight from 'react-animate-height';
import Icon, { ArrowDownCircleM, DuplicateS } from '@synerise/ds-icon';
import Scrollbar from '@synerise/ds-scrollbar';
import CopyAction from '../../CopyAction/CopyAction';
import Highlight from '../../Highlight/Highlight';
import { ICON_CLASSNAME, LINE_HEIGHT_DEFAULT } from '../SingleCode/SingleCode.styles';
import * as S from './MultiCode.styles';
var ANIMATE_HEIGHT_TIME = 300;
var MultiCode = function MultiCode(_ref) {
  var _ref$languages = _ref.languages,
    languages = _ref$languages === void 0 ? ['javascript', 'typescript', 'json'] : _ref$languages,
    _ref$children = _ref.children,
    children = _ref$children === void 0 ? '' : _ref$children,
    className = _ref.className,
    _ref$colorSyntax = _ref.colorSyntax,
    colorSyntax = _ref$colorSyntax === void 0 ? false : _ref$colorSyntax,
    tooltipTitleHover = _ref.tooltipTitleHover,
    tooltipTitleClick = _ref.tooltipTitleClick,
    labelBeforeExpanded = _ref.labelBeforeExpanded,
    labelAfterExpanded = _ref.labelAfterExpanded,
    _ref$wrap = _ref.wrap,
    wrap = _ref$wrap === void 0 ? false : _ref$wrap,
    _ref$rows = _ref.rows,
    rows = _ref$rows === void 0 ? 6 : _ref$rows,
    onExpand = _ref.onExpand,
    onCopy = _ref.onCopy,
    customTriggerComponent = _ref.customTriggerComponent,
    _ref$hideExpandButton = _ref.hideExpandButton,
    hideExpandButton = _ref$hideExpandButton === void 0 ? false : _ref$hideExpandButton,
    _ref$hideCopyButton = _ref.hideCopyButton,
    hideCopyButton = _ref$hideCopyButton === void 0 ? false : _ref$hideCopyButton,
    _ref$expanded = _ref.expanded,
    expanded = _ref$expanded === void 0 ? false : _ref$expanded;
  var _React$useState = React.useState(expanded),
    expandedState = _React$useState[0],
    setExpandedState = _React$useState[1];
  var _React$useState2 = React.useState(false),
    scrollable = _React$useState2[0],
    setScrollable = _React$useState2[1];
  var _React$useState3 = React.useState(1),
    allRows = _React$useState3[0],
    setAllRows = _React$useState3[1];
  var codeRef = React.useRef(null);
  var buttonProps = React.useMemo(function () {
    return {
      type: 'ghost',
      mode: 'icon-label',
      className: 'btn-expander',
      expanded: expandedState
    };
  }, [expandedState]);
  var initialContentHeight = React.useMemo(function () {
    var numberRows = allRows > rows ? rows : allRows;
    return (numberRows + 1) * LINE_HEIGHT_DEFAULT;
  }, [rows, allRows]);
  var onMounting = React.useCallback(function () {
    if (!!codeRef && !!(codeRef != null && codeRef.current)) {
      setAllRows(Math.round(codeRef.current.offsetHeight / LINE_HEIGHT_DEFAULT));
    }
  }, [codeRef]);
  React.useLayoutEffect(function () {
    onMounting();
  }, [onMounting, children, rows, wrap]);
  var handleButton = React.useCallback(function (isScroll) {
    setExpandedState(function (prevState) {
      return !prevState;
    });
    if (isScroll) {
      setTimeout(function () {
        return setScrollable(function (prevState) {
          return !prevState;
        });
      }, ANIMATE_HEIGHT_TIME);
    } else {
      setScrollable(function (prevState) {
        return !prevState;
      });
    }
    onExpand && onExpand();
  }, [onExpand]);
  var isButtonVisible = React.useMemo(function () {
    return allRows > rows + 1;
  }, [rows, allRows]);
  var extraHeightOption = React.useMemo(function () {
    return isButtonVisible ? initialContentHeight : 'auto';
  }, [isButtonVisible, initialContentHeight]);
  var multilineStructureContent = React.useMemo(function () {
    return /*#__PURE__*/React.createElement(S.PreBlock, {
      wrap: wrap,
      expanded: expandedState,
      isButtonVisible: isButtonVisible
    }, /*#__PURE__*/React.createElement(AnimateHeight, {
      className: "content-animation",
      duration: ANIMATE_HEIGHT_TIME,
      height: !expandedState ? extraHeightOption : 'auto',
      style: {
        minHeight: LINE_HEIGHT_DEFAULT
      }
    }, /*#__PURE__*/React.createElement(Scrollbar, {
      maxHeight: !scrollable ? (rows + 1) * LINE_HEIGHT_DEFAULT : '100%',
      style: {
        marginRight: '17px'
      }
    }, /*#__PURE__*/React.createElement(S.BlockCodeWrapperMulti, {
      ref: codeRef,
      isButtonVisible: isButtonVisible
    }, children))));
  }, [wrap, rows, expandedState, isButtonVisible, scrollable, codeRef, extraHeightOption, children]);
  var iconElement = React.useMemo(function () {
    return !hideCopyButton && /*#__PURE__*/React.createElement(CopyAction, {
      tooltipTitleHover: tooltipTitleHover,
      tooltipTitleClick: tooltipTitleClick,
      className: ICON_CLASSNAME,
      onClick: function onClick() {
        copy(children);
        onCopy && onCopy();
      },
      icon: /*#__PURE__*/React.createElement(DuplicateS, null),
      customTriggerComponent: customTriggerComponent
    });
  }, [children, tooltipTitleHover, tooltipTitleClick, onCopy, customTriggerComponent, hideCopyButton]);
  return /*#__PURE__*/React.createElement(S.CodeSnippetWrapperMulti, {
    expanded: expandedState,
    isButtonVisible: isButtonVisible,
    className: className
  }, /*#__PURE__*/React.createElement(S.ContentIconWrapper, null, colorSyntax && languages ? /*#__PURE__*/React.createElement(Highlight, {
    languages: languages
  }, multilineStructureContent) : multilineStructureContent, iconElement), !hideExpandButton && rows && isButtonVisible && /*#__PURE__*/React.createElement(S.ExpanderButton, _extends({}, buttonProps, {
    onClick: function onClick() {
      return handleButton(expandedState);
    }
  }), /*#__PURE__*/React.createElement(Icon, {
    component: /*#__PURE__*/React.createElement(ArrowDownCircleM, null)
  }), expandedState ? labelAfterExpanded : labelBeforeExpanded));
};
export default MultiCode;