import styled, { css } from 'styled-components';
import Button from '@synerise/ds-button';
import { IconContainer } from '@synerise/ds-icon';
import { BlockCodeWrapperSingle, CodeSnippetWrapperSingle, FONT_SIZE_DEFAULT, LINE_HEIGHT_DEFAULT } from '../SingleCode/SingleCode.styles';
export var ContentIconWrapper = styled.div.withConfig({
  displayName: "MultiCodestyles__ContentIconWrapper",
  componentId: "sc-1u5vxm9-0"
})(["position:relative;"]);
export var CodeSnippetWrapperMulti = styled(CodeSnippetWrapperSingle).withConfig({
  displayName: "MultiCodestyles__CodeSnippetWrapperMulti",
  componentId: "sc-1u5vxm9-1"
})(["&{min-width:250px;pre::before{background-color:", ";content:'';display:block;position:absolute;top:0;bottom:0;right:0;width:28px;z-index:10;}.content-animation{position:relative;}", ";}.copy{position:absolute;top:0;right:0;z-index:13;}"], function (props) {
  return props.theme.palette['grey-100'];
}, function (props) {
  return !!props.isButtonVisible && "\n        padding-bottom:7px;\n        .content-animation::after{\n            content:'';\n            display:block;\n            position:absolute;\n            bottom:0;\n            left:0;\n            right:0;\n            height:" + LINE_HEIGHT_DEFAULT + "px;\n            background-color:" + props.theme.palette['grey-100'] + ";\n            z-index:10;\n        }\n        ";
});
export var ExpanderButton = styled(Button).withConfig({
  displayName: "MultiCodestyles__ExpanderButton",
  componentId: "sc-1u5vxm9-2"
})(["&&{position:relative;z-index:15;top:-5px;", "{svg{transition:transform 0.2s linear;transform:rotate( ", " );}}}"], IconContainer, function (props) {
  return props.expanded ? '180deg' : '0deg';
});
export var BlockCodeWrapperMulti = styled(BlockCodeWrapperSingle).withConfig({
  displayName: "MultiCodestyles__BlockCodeWrapperMulti",
  componentId: "sc-1u5vxm9-3"
})(["&{padding-bottom:", ";}"], function (props) {
  return props.isButtonVisible ? '17px' : '12px';
});
export var PreBlock = styled.pre.withConfig({
  displayName: "MultiCodestyles__PreBlock",
  componentId: "sc-1u5vxm9-4"
})(["&{font-family:'IBM Plex Mono Regular',monospace;font-size:", "px;line-height:", "px;margin:0;", ";.ps__rail-x{height:", "px;z-index:11;opacity:0;}.ps__rail-x > .ps__thumb-x{bottom:", ";}.ps__rail-y{opacity:0;z-index:11;}}"], FONT_SIZE_DEFAULT, LINE_HEIGHT_DEFAULT, function (props) {
  return !!props.wrap && css(["white-space:pre-wrap;word-wrap:break-world;"]);
}, LINE_HEIGHT_DEFAULT, function (props) {
  return props.isButtonVisible ? '10px' : '6px';
});