import copy from 'copy-to-clipboard';
import React from 'react';
import { DuplicateS } from '@synerise/ds-icon';
import { FontSize } from '../../CodeSnippet.types';
import CopyAction from '../../CopyAction/CopyAction';
import * as S from './SingleCode.styles';
var SingleCode = function SingleCode(_ref) {
  var _ref$children = _ref.children,
    children = _ref$children === void 0 ? '' : _ref$children,
    _ref$fontSize = _ref.fontSize,
    fontSize = _ref$fontSize === void 0 ? FontSize.SMALL : _ref$fontSize,
    tooltipTitleHover = _ref.tooltipTitleHover,
    tooltipTitleClick = _ref.tooltipTitleClick,
    className = _ref.className,
    onCopy = _ref.onCopy,
    customTriggerComponent = _ref.customTriggerComponent;
  var iconElement = React.useMemo(function () {
    return /*#__PURE__*/React.createElement(CopyAction, {
      tooltipTitleHover: tooltipTitleHover,
      tooltipTitleClick: tooltipTitleClick,
      className: S.ICON_CLASSNAME,
      onClick: function onClick() {
        copy(children);
        onCopy && onCopy();
      },
      icon: /*#__PURE__*/React.createElement(DuplicateS, null),
      customTriggerComponent: customTriggerComponent,
      "data-testid": "ds-copy-code-snippet"
    });
  }, [children, tooltipTitleHover, tooltipTitleClick, onCopy, customTriggerComponent]);
  return /*#__PURE__*/React.createElement(S.CodeSnippetWrapperSingle, {
    fontSize: fontSize,
    className: className
  }, /*#__PURE__*/React.createElement(S.ContentIconWrapper, null, /*#__PURE__*/React.createElement(S.BlockCodeWrapperSingle, {
    fontSize: fontSize
  }, children), iconElement));
};
export default SingleCode;