import React from 'react';
import Icon from '@synerise/ds-icon';
import Tooltip from '@synerise/ds-tooltip';
import { useOnClickOutside } from '@synerise/ds-utils';
import * as S from './CopyAction.styles';
var CopyAction = function CopyAction(_ref) {
  var tooltipTitleHover = _ref.tooltipTitleHover,
    tooltipTitleClick = _ref.tooltipTitleClick,
    className = _ref.className,
    _onClick = _ref.onClick,
    icon = _ref.icon,
    iconSize = _ref.iconSize,
    customTriggerComponent = _ref.customTriggerComponent,
    _ref$timeToHideToolti = _ref.timeToHideTooltip,
    timeToHideTooltip = _ref$timeToHideToolti === void 0 ? 3000 : _ref$timeToHideToolti;
  var _React$useState = React.useState(false),
    hideHoverTooltip = _React$useState[0],
    setHideHoverTooltip = _React$useState[1];
  var iconRef = React.useRef(null);
  var timeoutClickRef = React.useRef(null);
  React.useEffect(function () {
    return function () {
      timeoutClickRef.current && clearTimeout(timeoutClickRef.current);
    };
  }, []);
  useOnClickOutside(iconRef, function () {
    if (hideHoverTooltip) {
      setHideHoverTooltip(false);
      timeoutClickRef.current && clearTimeout(timeoutClickRef.current);
    }
  });
  var handleIconClickTooltip = function handleIconClickTooltip() {
    timeoutClickRef.current && clearTimeout(timeoutClickRef.current);
    setHideHoverTooltip(true);
    timeoutClickRef.current = setTimeout(function () {
      setHideHoverTooltip(false);
    }, 3000);
  };
  return /*#__PURE__*/React.createElement(Tooltip, {
    title: tooltipTitleClick,
    trigger: "click",
    timeToHideAfterClick: timeToHideTooltip
  }, /*#__PURE__*/React.createElement(Tooltip, {
    title: tooltipTitleHover,
    overlayStyle: hideHoverTooltip ? {
      display: 'none'
    } : undefined
  }, /*#__PURE__*/React.createElement(S.IconWrapper, {
    customTriggerComponent: !!customTriggerComponent,
    ref: iconRef,
    className: className,
    onClick: function onClick(e) {
      !!e && e.stopPropagation();
      handleIconClickTooltip();
      _onClick && _onClick();
    }
  }, customTriggerComponent || /*#__PURE__*/React.createElement(Icon, {
    component: icon,
    size: iconSize || 24
  }))));
};
export default CopyAction;